--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    21:22:17 10/27/05
-- Design Name:    
-- Module Name:    dump - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity dump is
  port (
    CLK : in std_logic;
    LED : out std_logic_vector(7 downto 0);
    AA : out std_logic_vector(19 downto 0);
    ADVLDA : out std_logic;
    XRWA : out std_logic;
    CEA : out std_logic;
    BWA : out std_logic_vector(3 downto 0);
    CELA1X : out std_logic;
    CEHA1X : out std_logic;
    CEA2X : out std_logic;
    CEA2 : out std_logic;
    CLKMA0 : out std_logic;
    CLKMA1 : out std_logic;
    IOA : inout std_logic_vector(31 downto 0);
    IOPA : inout std_logic_vector(3 downto 0);
    LBOA : out std_logic;
    OEAX : out std_logic;
    ZZA : out std_logic;
    USBD : inout std_logic_vector(7 downto 0);
    USBRDX : out std_logic;
    USBWR : out std_logic;
    USBTXEX : in std_logic;
    USBRXFX : in std_logic;
    USBRSTX : out std_logic);

end dump;

architecture Behavioral of dump is
  signal RST : std_logic;
  signal BCLK : std_logic;
  signal CNT : std_logic_vector(4 downto 0);
  signal A : std_logic_vector(19 downto 0);
  signal D : std_logic_vector(7 downto 0);
  signal RDY : std_logic;

begin

  LED <= not A(19 downto 12);
  AA <= A;
  ADVLDA <= '0';
  XRWA <= '1';
  CEA <= '0';
  BWA <= "XXXX";
  CELA1X <= '0';
  CEHA1X <= '0';
  CEA2X <= '0';
  CEA2 <= '1';
  CLKMA0 <= BCLK;
  CLKMA1 <= BCLK;
  LBOA <= 'X';
  OEAX <= '0';
  ZZA <= '0';
  USBD <= D;
  USBRSTX <= not RST;
  USBRDX <= '1';
  USBWR <= RDY;
  
  IBG : IBUFG port map (
    I => CLK,
    O => BCLK);

  RC : ROC port map (
    O => RST);

  C: process (BCLK, RST)
  begin  -- process C
    if RST = '1' then               -- asynchronous reset (active high)
      CNT <= "00000";
      
    elsif BCLK'event and BCLK = '1' then  -- rising clock edge
      if CNT(2 downto 0) /= "000" or USBTXEX = '0' then
        CNT <= CNT + 1;
        
      end if;
      
    end if;
  end process C;

  AC: process (BCLK, RST)
  begin  -- process AC
    if RST = '1' then               -- asynchronous reset (active high)
      A <= "00000000000000000000";
      
    elsif BCLK'event and BCLK = '1' then  -- rising clock edge
      if CNT = "11111" then
        A <= A + 1;
        
      end if;
      
    end if;
  end process AC;

  I: process (BCLK, RST)
  begin  -- process I
    if RST = '1' then                   -- asynchronous reset (active high)
      
    elsif BCLK'event and BCLK = '1' then  -- rising clock edge
      case CNT(4 downto 3) is
        when "00" => D <= IOA(31 downto 24);
        when "01" => D <= IOA(23 downto 16);
        when "10" => D <= IOA(15 downto 8);
        when "11" => D <= IOA(7 downto 0);
        when others => null;
      end case;
      
    end if;
  end process I;

  O: process (BCLK, RST)
  begin  -- process O
    if RST = '1' then                   -- asynchronous reset (active high)
      RDY <= '0';
      
    elsif BCLK'event and BCLK = '1' then  -- rising clock edge
      case CNT(2 downto 0) is
        when "001" => RDY <= '1';
        when "100" => RDY <= '0';
        when others => null;        
      end case;
      
    end if;
  end process O;
  
end Behavioral;
